package de.hsel.spm.baudas.web;

import org.jetbrains.annotations.NotNull;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * authenticates users.
 *
 * @author Edgar Schkrob
 * @version 0.1
 * @since 1.0
 */

@WebServlet("/login")
public class LoginServlet extends HttpServlet {

    private final String password = "SPM2019SS";

    /**
     * reads from HTTP POST parameter 'password' and compares it.
     *
     * @param request  request object
     * @param response response object
     * @throws IOException failed to initialize print writer
     */
    @Override
    protected void doPost(@NotNull HttpServletRequest request, @NotNull HttpServletResponse response) throws ServletException, IOException {
        String password = request.getParameter("password");
        if (this.password.equals(password)) {
            HttpSession newSession = request.getSession(true);
            newSession.setAttribute("authentication", true);
            newSession.setMaxInactiveInterval(5 * 60 * 60); //setting session to expiry in 5 hours
            response.sendRedirect("/");
        } else {
            RequestDispatcher rd = getServletContext().getRequestDispatcher("/login.jsp");
            PrintWriter out = response.getWriter();
            out.println("<font color='red' class='align-center'>Das eingegebene Passwort ist falsch.</font>");
            rd.include(request, response);
        }
    }
}
